use crate::utils;

pub fn execute_task01(content: &str) {
    let vector = utils::convert_to_string_slice(&content);
    let mut sum_vector = collect_all_calories(vector);
    sort_calories_descending(&mut sum_vector);

    let max: i32 = sum_vector[0];

    println!("Day01 - Task01 - Biggest Calories {}", max)
}

pub fn execute_task02(content: &str) {
    let vector = utils::convert_to_string_slice(&content);
    let mut sum_vector = collect_all_calories(vector);
    sort_calories_descending(&mut sum_vector);

    let max_three: i32 = sum_vector.iter().take(3).sum();

    println!("Day01 - Task02 - Biggest Calories of top three: {}", max_three);
}

fn collect_all_calories(list: Vec<&str>) -> Vec<i32> {
    let mut calories: i32 = 0;
    let mut calories_list: Vec<i32> = vec![];

    for var in list {

        if var.is_empty() {
            calories_list.push(calories);
            calories = 0;
            continue;
        }

        calories += var.parse::<i32>().unwrap_or(0);
    }

    return calories_list;
}

fn sort_calories_descending(vec: &mut Vec<i32>) {
    vec.sort_by_key(|a|

        std::cmp::Reverse(*a));
}
